/*
 *  Copyright (C) 2010-2018. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SWITCH_IB_H__
#define __SWITCH_IB_H__
/************************************************
 *  Local Defines
 ***********************************************/

/************************************************
 *  Local Macros
 ***********************************************/

/************************************************
 *  Local Type definitions
 ***********************************************/

/************************************************
 *  Defines
 ***********************************************/


#define SWITCH_IB_ACL_INGRESS_GROUPS_MAX                       0
#define SWITCH_IB_ACL_ENGRESS_GROUPS_MAX                       0
#define SWITCH_IB_ACL_GROUPS_SIZE_MAX                          0
#define SWITCH_IB_ACL_GROUPS_NUM_MIN                           0
#define SWITCH_IB_ACL_GROUPS_NUM_MAX                           0
#define SWITCH_IB_ACL_RULES_BLOCK_MAX                          0
#define SWITCH_IB_ACL_RULES_NUM_MIN                            0
#define SWITCH_IB_ACL_RULES_NUM_MAX                            0
#define SWITCH_IB_ACL_PBS_ENTRIES_MAX                          0
#define SWITCH_IB_ACL_PORT_RANGES_MAX                          0
#define SWITCH_IB_ACL_REGIONS_MAX                              0
#define SWITCH_IB_ACL_INGRESS_TABLES_MAX                       0
#define SWITCH_IB_ACL_EGRESS_TABLES_MAX                        0
#define SWITCH_IB_ACL_TABLES_MAX                               0
#define SWITCH_IB_ACL_VLAN_GROUPS_MAX                          0
#define SWITCH_IB_ACL_TRAP_GROUPS_MAX                          0
#define SWITCH_IB_ACL_MAX_FLEX_KEYS                            0
#define SWITCH_IB_ACL_MAX_ACTIONS_PER_RULE                     0
#define SWITCH_IB_ACL_MAX_ACTIONS_PER_SET                      0
#define SWITCH_IB_ACL_EXTENDED_ACTIONS_NUM_MIN                 0
#define SWITCH_IB_ACL_EXTENDED_ACTIONS_NUM_MAX                 0
#define SWITCH_IB_ACL_PARSING_DEPTH                            0
#define SWITCH_IB_ACL_CUSTOM_BYTES_SET_MAX                     0
#define SWITCH_IB_ACL_CUSTOM_BYTES_SET_SIZE_MAX                0
#define SWITCH_IB_ACL_CUSTOM_BYTES_EXTRACTION_POINT_OFFSET_MAX 0
#define SWITCH_IB_ACL_PBILM_ENTRIES_MAX                        0

#define SWITCH_IB_ROUTER_RIFS_MAX                      0
#define SWITCH_IB_ROUTER_RIFS_DONTCARE                 0
#define SWITCH_IB_ROUTER_SUB_PORT_FID_START_INDEX      0
#define SWITCH_IB_ROUTER_IPV4_UC_MAX                   0
#define SWITCH_IB_ROUTER_IPV4_MC_MAX                   0
#define SWITCH_IB_ROUTER_IPV6_UC_MAX                   0
#define SWITCH_IB_ROUTER_IPV6_MC_MAX                   0
#define SWITCH_IB_ROUTER_ECMP_MAX                      0
#define SWITCH_IB_ROUTER_ECMP_HASH_MAX                 0
#define SWITCH_IB_ROUTER_NEIGHS_MAX                    0
#define SWITCH_IB_ROUTER_ADJ_MAX                       0
#define SWITCH_IB_ROUTER_VRID_MAX                      0
#define SWITCH_IB_ROUTER_COUNTERS_ID_MAX               0
#define SWITCH_IB_ROUTER_NEXT_HOP_MAX                  0
#define SWITCH_IB_ROUTER_ECMP_CONTAINER_TOT_WEIGHT_MAX 0
#define SWITCH_IB_SHSPM_TREE_MAX                       0
#define SWITCH_IB_SHSPM_ENTRY_MAX                      0
#define SWITCHX_IB_MC_RPF_GROUP_MAX                    0

#define SWITCH_IB_IB_ROUTER_LIDS_MAX        49152
#define SWITCH_IB_IB_ROUTER_MC_LIDS_NUM_MAX 0x4000   /*16k*/
#define SWITCH_IB_IB_ROUTER_UC_LID_NUM_MAX  0xc000   /*48k*/
#define SWITCH_IB_IB_PKEYS_TABLE_SIZE       32

#define SWITCH_IB_FCF_PORT_DENSITY_MAX 0
#define SWITCH_IB_FCF_ZONES_PAIRS_MAX  0
#define SWITCH_IB_FCF_ZONES_GROUPS_MAX 0
#define SWITCH_IB_FCF_GATEWAY_MAX      0
#define SWITCH_IB_FCF_RULES_MAX        0

#define SWITCH_IB_PORT_LCL_NUM_MAX             72
#define SWITCH_IB_PORT_EXT_NUM_MAX             64
#define SWITCH_IB_PORT_LOG_NUM_MAX             4096
#define SWITCH_IB_PORT_MTU_MAX                 10000
#define SWITCH_IB_PORT_MTU_MIN                 68
#define SWITCH_IB_PORT_STORM_CONTROL_ID_MAX    4
#define SWITCH_IB_PORT_VEPA_CHANNELS_NUM_MAX   0
#define SWITCH_IB_PORT_SYSTEM_PORTS_MAX        64
#define SWITCH_IB_PORT_SYSTEM_PORT_MODULES_MAX 64
#define SWITCH_IB_IB_PORTS_MAX                 36

#define SWITCH_IB_LAG_NUM_MAX          0
#define SWITCH_IB_LAG_PORT_MEMBERS_MAX 0
#define SWITCH_IB_LAG_VECTORS_NUM_MAX  0

#define SWITCH_IB_SPAN_SESSION_ID_MAX 6

#define SWITCH_IB_FDB_MID_MAX         0
#define SWITCH_IB_FDB_MID_START_INDEX 0
#define SWITCH_IB_FDB_PGT_MAX         0
#define SWITCH_IB_FDB_UC_ADDRESS_MAX  0
#define SWITCH_IB_FDB_MC_ADDRESS_MAX  0

#define SWITCH_IB_FLOODING_TABLE_MAX         2
#define SWITCH_IB_FLOODING_TABLE_PER_VID_MAX 1

#define SWITCH_IB_SWID_ID_MAX 7

#define SWITCH_IB_POLICER_POOL_SIZE               0
#define SWITCH_IB_POLICER_HOST_IFC_POOL_SIZE      0
#define SWITCH_IB_POLICER_STORM_CONTROL_POOL_SIZE 0
#define SWITCH_IB_POLICER_BS_MIN_VALUE_PACKETS    0
#define SWITCH_IB_POLICER_BS_MIN_VALUE_BYTES      0
#define SWITCH_IB_POLICER_BS_MAX_VALUE            0

#define SWITCH_IB_COS_TRAFFIC_CLASS_MAX             0
#define SWITCH_IB_COS_PORT_ETS_SUB_GROUP_MAX        0
#define SWITCH_IB_COS_PORT_ETS_GROUP_MAX            0
#define SWITCH_IB_COS_PORT_PRIO_MAX                 0
#define SWITCH_IB_COS_PORT_COLOR_MAX                0
#define SWITCH_IB_COS_PORT_ETS_ELEMENTS_NUM         0
#define SWITCH_IB_COS_BUFFER_64K_SIZE_MAX           0
#define SWITCH_IB_COS_BUFFER_128K_SIZE_MAX          0
#define SWITCH_IB_COS_REDECN_DEFAULT_AQS_WEIGHT     0
#define SWITCH_IB_COS_REDECN_RED_DROP_ENABLED       FALSE
#define SWITCH_IB_COS_REDECN_SCD                    FALSE
#define SWITCH_IB_COS_REDECN_PROFILES_MAX           0
#define SWITCH_IB_COS_REDECN_CELL_MULTIPLIER        0
#define SWITCH_IB_COS_REDECN_DEFAULT_TC_RED_ENABLED FALSE
#define SWITCH_IB_COS_REDECN_DEFAULT_TC_ECN_ENABLED FALSE
#define SWITCH_IB_BRIDGE_NUM_MAX                    0

#define SWITCH_IB_TOTAL_TCAM                  0
#define SWITCH_IB_TOTAL_L3_REPLICATION_MATRIX 0

/*SW TABLE -> HW TABLE MAPPING */

#define SWITCH_IB_FDB_UC_MAC_HW_TABLE_TYPE /*sfd*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCH_IB_FDB_MC_MAC_HW_TABLE_TYPE /*sfd*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCH_IB_ROUTER_IPV4_UC_HW_TABLE_TYPE/*ruft*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCH_IB_ROUTER_IPV6_UC_HW_TABLE_TYPE/*ruft*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCH_IB_ROUTER_IPV4_MC_HW_TABLE_TYPE/*rmft*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCH_IB_ROUTER_IPV6_MC_HW_TABLE_TYPE/*rmft*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCH_IB_ROUTER_ARP_IPV4_HW_TABLE_TYPE/*ruht*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCH_IB_ROUTER_ARP_IPV6_HW_TABLE_TYPE/*ruht*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCH_IB_ROUTER_MC_REPLICATIONS_HW_TABLE_TYPE/*rigr*/ RM_HW_TABLE_TYPE_REPLICATION_MATRIX_E

#define SWITCH_IB_ROUTER_ADJACENCY_HW_TABLE_TYPE/*ratr*/ RM_HW_TABLE_TYPE_ADJACENCY_E

#define SWITCH_IB_L2_MC_MIDS_HW_TABLE_TYPE/*smid*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCH_IB_LAG_VECTORS_HW_TABLE_TYPE/*sldr*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCH_IB_L2_MC_FLOODING_HW_TABLE_TYPE/*sftr*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCH_IB_FCF_FORWORDING_HW_TABLE_TYPE/*fftr*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCH_IB_ACL_RULES_HW_TABLE_TYPE /*ptce*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCH_IB_ACL_GROUPS_HW_TABLE_TYPE RM_HW_TABLE_TYPE_ACL_GROUP_TABLE_E

#define SWITCH_IB_ACL_EXTENDED_ACTIONS_HW_TABLE_TYPE RM_HW_TABLE_TYPE_INVALID


/*phy_entry_cost per table */

#define SWITCH_IB_FDB_UC_MAC_HW_ENTRY_COST 1
#define SWITCH_IB_FDB_MC_MAC_HW_ENTRY_COST 1

#define SWITCH_IB_ROUTER_IPV4_UC_HW_ENTRY_COST/*ruft*/ 1
#define SWITCH_IB_ROUTER_IPV6_UC_HW_ENTRY_COST/*ruft*/ 1
#define SWITCH_IB_ROUTER_IPV4_MC_HW_ENTRY_COST/*rmft*/ 1
#define SWITCH_IB_ROUTER_IPV6_MC_HW_ENTRY_COST/*rmft*/ 1

#define SWITCH_IB_ROUTER_ARP_IPV4_HW_ENTRY_COST/*ruft*/ 1
#define SWITCH_IB_ROUTER_ARP_IPV6_HW_ENTRY_COST/*ruft*/ 1

#define SWITCH_IB_ROUTER_MC_REPLICATIONS_HW_ENTRY_COST/*rigr*/ 1

#define SWITCH_IB_ROUTER_ADJACENCY_HW_ENTRY_COST/*ratr*/ 1

#define SWITCH_IB_L2_MC_MIDS_HW_ENTRY_COST/*smid*/ 1

#define SWITCH_IB_LAG_VECTORS_ENTRY_COST 1

#define SWITCH_IB_L2_MC_FLOODING_HW_ENTRY_COST/*sftr*/ 1

#define SWITCH_IB_FCF_FORWORDING_HW_ENTRY_COST/*fftr*/ 1

#define SWITCH_IB_ACL_RULES_HW_ENTRY_COST /*ptce*/ 1

#define SWITCH_IB_ACL_GROUPS_HW_ENTRY_COST           1
#define SWITCH_IB_ACL_EXTENDED_ACTIONS_HW_ENTRY_COST 0

#define SWITCHX_IB_BUFFERS_TOTAL_MEMORY           0
#define SWITCH_IB_DESCRIPTOR_BUFFERS_TOTAL_MEMORY 0
#define SWITCH_IB_MAX_TOTAL_HEADROOM_SIZE         0
#define SWITCH_IB_HEADROOM_NUM_BUFF_PER_PORT      9
/* Shared buffers - Condor */
#define SWITCH_IB_SHARED_BUFF_NUM_ING_POOL_PER_PORT  0
#define SWITCH_IB_SHARED_BUFF_NUM_EGR_POOL_PER_PORT  0
#define SWITCH_IB_SHARED_BUFF_NUM_MC_POOL_PER_PORT   0
#define SWITCH_IB_SHARED_BUFF_NUM_ING_DESC_PER_PORT  0
#define SWITCH_IB_SHARED_BUFF_NUM_EGR_DESC_PER_PORT  0
#define SWITCH_IB_SHARED_BUFF_NUM_MANAGMENT_POOL     0
#define SWITCH_IB_SHARED_BUFF_TOTAL_NUM_POOL         0
#define SWITCH_IB_SHARED_BUFF_NUM_EGR_BUFF_PER_PORT  0
#define SWITCH_IB_SHARED_BUFF_NUM_ING_BUFF_PER_PORT  0
#define SWITCH_IB_SHARED_BUFF_MAX_POOL_SIZE          0
#define SWITCH_IB_SHARED_BUFF_PORT_NUM_MAX           0
#define SWITCH_IB_SHARED_BUFF_TCLASS_NUM_MAX         0
#define SWITCH_IB_SHARED_BUFF_RET_STATISTICS_NUM_MAX 0
#define SWITCH_IB_BUFF_UNIT_SIZE                     96
#define SWITCH_IB_SHARED_BUFF_MC_MAX_NUM_PRIO        0

#define SWITCH_IB_KVD_SIZE 0

#define SWITCHX_IB_NUM_HW_CPU_INGRESS_TCLASS_MAX 32
#define SWITCHX_IB_NUM_HW_DR_PATHS_MAX           0
#define SWITCHX_IB_NUM_HW_TRAP_GROUPS_MAX        5
#define SWITCHX_IB_TRAP_GROUP_PRIORITY_MIN       0
#define SWITCHX_IB_TRAP_GROUP_PRIORITY_MAX       4
#define SWITCHX_IB_NUM_RDQS_MAX                  32
#define SWITCHX_IB_NUM_CPU_TCLASS                4
#define SWITCH_IB_KVD_HASH_SINGLE_MIN_SIZE       0
#define SWITCH_IB_KVD_HASH_DOUBLE_MIN_SIZE       0
#define SWITCHX_IB_KVD_GUARANTEED_CAPACITY       0
#define SWITCH_IB_KVD_LINEAR_VIRTUAL_TABLE_SIZE  0

#define SWITCHX_IB_PGT_SIZE  0
#define SWITCHX_IB_RMPE_SIZE 0

/* SW Counter Allocation - Only used on some chips */
#define SWITCHX_IB_CNTR_BANK_PAIRS         0
#define SWITCHX_IB_CNTR_LINES_PER_BANK     0
#define SWITCHX_IB_CNTR_LINES_FLOW_PKT     0
#define SWITCHX_IB_CNTR_TYPE_FLOW_PKT      0
#define SWITCHX_IB_CNTR_LINES_FLOW_BYTE    0
#define SWITCHX_IB_CNTR_TYPE_FLOW_BYTE     0
#define SWITCHX_IB_CNTR_LINES_FLOW_BOTH    0
#define SWITCHX_IB_CNTR_TYPE_FLOW_BOTH     0
#define SWITCHX_IB_CNTR_LINES_RIF_BASIC    0
#define SWITCHX_IB_CNTR_TYPE_RIF_BASIC     0
#define SWITCHX_IB_CNTR_LINES_RIF_MIXED_1  0
#define SWITCHX_IB_CNTR_TYPE_RIF_MIXED_1   0
#define SWITCHX_IB_CNTR_LINES_RIF_MIXED_2  0
#define SWITCHX_IB_CNTR_TYPE_RIF_MIXED_2   0
#define SWITCHX_IB_CNTR_LINES_RIF_ENHANCED 0
#define SWITCHX_IB_CNTR_TYPE_RIF_ENHANCED  0


/* Tunnel */
#define SWITCH_IB_NUM_MAX_TUNNEL_IPINIP         0   /* Not supported */
#define SWITCH_IB_NUM_MAX_TUNNEL_NVE            0   /* Not supported */
#define SWITCH_IB_TUNNEL_NVE_GS_FLOOD_MAX       0   /* Not supported */
#define SWITCH_IB_TUNNEL_NVE_GS_MC_MAX          0 /* Not supported */
#define SWITCH_IB_TUNNEL_TNUMT_IPV6_RECORDS_MAX 0   /* Not supported */

/* IGMP V3 */
#define SWITCH_IB_IGMP_V3_NUM_MAX_ENTRIES 0        /* Not supported */

/* Telemetry */
#define SWITCH_IB_TELE_HISTOGRAM_NUM_MAX                    0
#define SWITCH_IB_TELE_HISTOGRAM_QUEUE_DEPTH_BINS           0
#define SWITCH_IB_TELE_HISTOGRAM_SAMPLE_TIME_RESOLUTION_MAX 0
#define SWITCH_IB_TELE_HISTOGRAM_BIN_SIZE_RESOLUTION_MIN    0
#define SWITCH_IB_TELE_HISTOGRAM_BIN_SIZE_RESOLUTION_MAX    0
#define SWITCH_IB_TELE_HISTOGRAM_DATA_BIN_BITS_MAX          23
#define SWITCH_IB_TELE_HISTOGRAM_MIN_BOUNDARY_MIN           1
#define SWITCH_IB_TELE_THRESHOLD_NUM_MAX \
    (SWITCH_IB_LAG_NUM_MAX +             \
     SWITCH_IB_PORT_EXT_NUM_MAX) *       \
    SWITCH_IB_COS_TRAFFIC_CLASS_MAX
#define SWITCH_IB_TELE_THRESHOLD_THR_MAX 0xFFFFFF

#define SWITCH_IB_INVALID_SW_TABLE_TYPE RM_SDK_TABLE_TYPE_INVALID_E

/************************************************
 *  Macros
 ***********************************************/

/************************************************
 *  Type definitions
 ***********************************************/

/************************************************
 *  Global variables
 ***********************************************/

static const rm_resources_t rm_resource_switch_ib = {
    /*13*/
    SWITCH_IB_ACL_INGRESS_GROUPS_MAX,
    SWITCH_IB_ACL_ENGRESS_GROUPS_MAX,
    SWITCH_IB_ACL_GROUPS_SIZE_MAX,
    SWITCH_IB_ACL_GROUPS_NUM_MAX,
    SWITCH_IB_ACL_RULES_BLOCK_MAX,
    SWITCH_IB_ACL_PBS_ENTRIES_MAX,
    SWITCH_IB_ACL_PORT_RANGES_MAX,
    SWITCH_IB_ACL_REGIONS_MAX,
    SWITCH_IB_ACL_INGRESS_TABLES_MAX,
    SWITCH_IB_ACL_EGRESS_TABLES_MAX,
    SWITCH_IB_ACL_TABLES_MAX,
    SWITCH_IB_ACL_VLAN_GROUPS_MAX,
    SWITCH_IB_ACL_TRAP_GROUPS_MAX,
    SWITCH_IB_ACL_MAX_FLEX_KEYS,
    SWITCH_IB_ACL_MAX_ACTIONS_PER_RULE,
    SWITCH_IB_ACL_MAX_ACTIONS_PER_SET,
    SWITCH_IB_ACL_PARSING_DEPTH,
    SWITCH_IB_ACL_CUSTOM_BYTES_SET_MAX,
    SWITCH_IB_ACL_CUSTOM_BYTES_SET_SIZE_MAX,
    SWITCH_IB_ACL_CUSTOM_BYTES_EXTRACTION_POINT_OFFSET_MAX,
    SWITCH_IB_ACL_PBILM_ENTRIES_MAX,

    /*26*/
    SWITCH_IB_ROUTER_RIFS_MAX,
    SWITCH_IB_ROUTER_RIFS_DONTCARE,
    SWITCH_IB_ROUTER_SUB_PORT_FID_START_INDEX,
    SWITCH_IB_ROUTER_IPV4_UC_MAX,
    SWITCH_IB_ROUTER_IPV4_MC_MAX,
    SWITCH_IB_ROUTER_IPV6_UC_MAX,
    SWITCH_IB_ROUTER_IPV6_MC_MAX,
    SWITCH_IB_ROUTER_ECMP_MAX,
    SWITCH_IB_ROUTER_ECMP_HASH_MAX,
    SWITCH_IB_ROUTER_ADJ_MAX,
    SWITCH_IB_ROUTER_NEIGHS_MAX,
    SWITCH_IB_ROUTER_VRID_MAX,
    SWITCH_IB_ROUTER_COUNTERS_ID_MAX,
    SWITCH_IB_ROUTER_NEXT_HOP_MAX,
    SWITCH_IB_ROUTER_ECMP_CONTAINER_TOT_WEIGHT_MAX,
    SWITCH_IB_SHSPM_TREE_MAX,
    SWITCH_IB_SHSPM_ENTRY_MAX,
    SWITCHX_IB_MC_RPF_GROUP_MAX,

    /*5*/
    SWITCH_IB_FCF_PORT_DENSITY_MAX,
    SWITCH_IB_FCF_ZONES_PAIRS_MAX,
    SWITCH_IB_FCF_ZONES_GROUPS_MAX,
    SWITCH_IB_FCF_GATEWAY_MAX,
    SWITCH_IB_FCF_RULES_MAX,

    /*8*/
    SWITCH_IB_PORT_LCL_NUM_MAX,
    SWITCH_IB_PORT_EXT_NUM_MAX,
    SWITCH_IB_PORT_LOG_NUM_MAX,
    SWITCH_IB_PORT_MTU_MAX,
    SWITCH_IB_PORT_MTU_MIN,
    SWITCH_IB_PORT_STORM_CONTROL_ID_MAX,
    SWITCH_IB_PORT_VEPA_CHANNELS_NUM_MAX,
    SWITCH_IB_PORT_SYSTEM_PORTS_MAX,
    SWITCH_IB_PORT_SYSTEM_PORT_MODULES_MAX,

    /*6*/
    SWITCH_IB_LAG_NUM_MAX,
    SWITCH_IB_LAG_PORT_MEMBERS_MAX,

    SWITCH_IB_SPAN_SESSION_ID_MAX,
    SWITCH_IB_SPAN_SESSION_ID_MAX,

    SWITCH_IB_FDB_MID_MAX,
    SWITCH_IB_FDB_MID_START_INDEX,
    SWITCH_IB_FDB_PGT_MAX,
    SWITCH_IB_FDB_UC_ADDRESS_MAX,
    SWITCH_IB_FDB_MC_ADDRESS_MAX,

    SWITCH_IB_FLOODING_TABLE_MAX,
    SWITCH_IB_FLOODING_TABLE_PER_VID_MAX,

    SWITCH_IB_COS_TRAFFIC_CLASS_MAX,
    SWITCH_IB_COS_PORT_ETS_SUB_GROUP_MAX,
    SWITCH_IB_COS_PORT_ETS_GROUP_MAX,
    SWITCH_IB_COS_PORT_PRIO_MAX,
    SWITCH_IB_COS_PORT_COLOR_MAX,
    SWITCH_IB_COS_PORT_ETS_ELEMENTS_NUM,
    SWITCH_IB_COS_BUFFER_64K_SIZE_MAX,
    SWITCH_IB_COS_BUFFER_128K_SIZE_MAX,
    SWITCH_IB_COS_REDECN_DEFAULT_AQS_WEIGHT,
    SWITCH_IB_COS_REDECN_RED_DROP_ENABLED,
    SWITCH_IB_COS_REDECN_SCD,
    SWITCH_IB_COS_REDECN_PROFILES_MAX,
    SWITCH_IB_COS_REDECN_CELL_MULTIPLIER,
    SWITCH_IB_COS_REDECN_DEFAULT_TC_RED_ENABLED,
    SWITCH_IB_COS_REDECN_DEFAULT_TC_ECN_ENABLED,

    SWITCH_IB_SWID_ID_MAX,

    SWITCH_IB_POLICER_POOL_SIZE,
    SWITCH_IB_POLICER_HOST_IFC_POOL_SIZE,
    SWITCH_IB_POLICER_STORM_CONTROL_POOL_SIZE,
    SWITCH_IB_POLICER_BS_MIN_VALUE_PACKETS,
    SWITCH_IB_POLICER_BS_MIN_VALUE_BYTES,
    SWITCH_IB_POLICER_BS_MAX_VALUE,
    SWITCH_IB_KVD_SIZE,
    SWITCH_IB_KVD_HASH_SINGLE_MIN_SIZE,
    SWITCH_IB_KVD_HASH_DOUBLE_MIN_SIZE,
    SWITCHX_IB_KVD_GUARANTEED_CAPACITY,
    SWITCH_IB_KVD_LINEAR_VIRTUAL_TABLE_SIZE,

    SWITCHX_IB_PGT_SIZE,
    SWITCHX_IB_RMPE_SIZE,

    SWITCH_IB_BRIDGE_NUM_MAX,

    SWITCHX_IB_BUFFERS_TOTAL_MEMORY,
    SWITCH_IB_DESCRIPTOR_BUFFERS_TOTAL_MEMORY,
    SWITCH_IB_MAX_TOTAL_HEADROOM_SIZE,
    SWITCH_IB_HEADROOM_NUM_BUFF_PER_PORT,
    /* Shared buffers - Condor */
    SWITCH_IB_SHARED_BUFF_NUM_ING_POOL_PER_PORT,
    SWITCH_IB_SHARED_BUFF_NUM_EGR_POOL_PER_PORT,
    SWITCH_IB_SHARED_BUFF_NUM_MC_POOL_PER_PORT,
    SWITCH_IB_SHARED_BUFF_NUM_ING_DESC_PER_PORT,
    SWITCH_IB_SHARED_BUFF_NUM_EGR_DESC_PER_PORT,
    SWITCH_IB_SHARED_BUFF_NUM_MANAGMENT_POOL,
    SWITCH_IB_SHARED_BUFF_TOTAL_NUM_POOL,
    SWITCH_IB_SHARED_BUFF_NUM_EGR_BUFF_PER_PORT,
    SWITCH_IB_SHARED_BUFF_NUM_ING_BUFF_PER_PORT,
    SWITCH_IB_SHARED_BUFF_MAX_POOL_SIZE,
    SWITCH_IB_SHARED_BUFF_PORT_NUM_MAX,
    SWITCH_IB_SHARED_BUFF_TCLASS_NUM_MAX,
    SWITCH_IB_SHARED_BUFF_RET_STATISTICS_NUM_MAX,
    SWITCH_IB_BUFF_UNIT_SIZE,
    SWITCH_IB_SHARED_BUFF_MC_MAX_NUM_PRIO,

    {
        /* RM_SDK_TABLE_TYPE_UC_MAC_E = 0 */
        {SWITCH_IB_FDB_UC_ADDRESS_MAX,
         SWITCH_IB_FDB_UC_ADDRESS_MAX,
         SWITCH_IB_FDB_UC_MAC_HW_ENTRY_COST,
         SWITCH_IB_FDB_UC_MAC_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_MC_MAC_E = 1 */
        {SWITCH_IB_FDB_MC_ADDRESS_MAX,
         SWITCH_IB_FDB_MC_ADDRESS_MAX,
         SWITCH_IB_FDB_MC_MAC_HW_ENTRY_COST,
         SWITCH_IB_FDB_MC_MAC_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV4_UC_E = 2 */
        {SWITCH_IB_ROUTER_IPV4_UC_MAX,
         SWITCH_IB_ROUTER_IPV4_UC_MAX,
         SWITCH_IB_ROUTER_IPV4_UC_HW_ENTRY_COST,
         SWITCH_IB_ROUTER_IPV4_UC_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV6_UC_E = 3 */
        {SWITCH_IB_ROUTER_IPV6_UC_MAX,
         SWITCH_IB_ROUTER_IPV6_UC_MAX,
         SWITCH_IB_ROUTER_IPV6_UC_HW_ENTRY_COST,
         SWITCH_IB_ROUTER_IPV6_UC_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV4_MC_E = 4 */
        {SWITCH_IB_ROUTER_IPV4_MC_MAX,
         SWITCH_IB_ROUTER_IPV4_MC_MAX,
         SWITCH_IB_ROUTER_IPV4_MC_HW_ENTRY_COST,
         SWITCH_IB_ROUTER_IPV4_MC_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV6_MC_E = 5 */
        {SWITCH_IB_ROUTER_IPV6_MC_MAX,
         SWITCH_IB_ROUTER_IPV6_MC_MAX,
         SWITCH_IB_ROUTER_IPV6_MC_HW_ENTRY_COST,
         SWITCH_IB_ROUTER_IPV6_MC_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ARP_IPV4_E = 6 */
        {SWITCH_IB_ROUTER_NEIGHS_MAX,
         SWITCH_IB_ROUTER_NEIGHS_MAX,
         SWITCH_IB_ROUTER_ARP_IPV4_HW_ENTRY_COST,
         SWITCH_IB_ROUTER_ARP_IPV4_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ARP_IPV6_E = 7 */
        {SWITCH_IB_ROUTER_NEIGHS_MAX,
         SWITCH_IB_ROUTER_NEIGHS_MAX,
         SWITCH_IB_ROUTER_ARP_IPV6_HW_ENTRY_COST,
         SWITCH_IB_ROUTER_ARP_IPV6_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_L3_MC_REPLICATIONS_E = 8 */
        {SWITCH_IB_TOTAL_L3_REPLICATION_MATRIX,
         SWITCH_IB_TOTAL_L3_REPLICATION_MATRIX,
         SWITCH_IB_ROUTER_MC_REPLICATIONS_HW_ENTRY_COST,
         SWITCH_IB_ROUTER_MC_REPLICATIONS_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ADJACENCY_E = 9 */
        {SWITCH_IB_ROUTER_ADJ_MAX,
         SWITCH_IB_ROUTER_ADJ_MAX,
         SWITCH_IB_ROUTER_ADJACENCY_HW_ENTRY_COST,
         SWITCH_IB_ROUTER_ADJACENCY_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_L2_MC_VECTORS_E = 10 */
        {SWITCH_IB_FDB_MID_MAX,
         SWITCH_IB_FDB_MID_MAX,
         SWITCH_IB_L2_MC_MIDS_HW_ENTRY_COST,
         SWITCH_IB_L2_MC_MIDS_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_LAG_VECTORS_E = 11 */
        {SWITCH_IB_LAG_VECTORS_NUM_MAX,
         SWITCH_IB_LAG_VECTORS_NUM_MAX,
         SWITCH_IB_LAG_VECTORS_ENTRY_COST,
         SWITCH_IB_LAG_VECTORS_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FLOOD_VECTORS_E = 12 */
        {SWITCH_IB_FLOODING_TABLE_MAX,
         SWITCH_IB_FLOODING_TABLE_MAX,
         SWITCH_IB_L2_MC_FLOODING_HW_ENTRY_COST,
         SWITCH_IB_L2_MC_FLOODING_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},


        /* RM_SDK_TABLE_TYPE_ACL_EXTENDED_ACTIONS_E = 13 */
        {SWITCH_IB_ACL_EXTENDED_ACTIONS_NUM_MIN,
         SWITCH_IB_ACL_EXTENDED_ACTIONS_NUM_MAX,
         SWITCH_IB_ACL_EXTENDED_ACTIONS_HW_ENTRY_COST,
         SWITCH_IB_ACL_EXTENDED_ACTIONS_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_PBS_E = 14 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ERIF_LIST_E = 15 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_TUNNEL_RTDP_E = 16 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},


        /* RM_SDK_TABLE_TYPE_ILM_E = 17 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RPF_GROUP_E = 18 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_VLAN_E = 19 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_VPORTS_E = 20 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FID_E = 21 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_VNI_E = 22 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_TUNNEL_IPV6_FDB_E = 23 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_MPLS_NHLFE_E = 24 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_PB_MPLS_ILM_E = 25 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_NVE_IPV6_LIST_E = 26 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_E = 27 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIPS_E = 28 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_IGMP_V3_IPv4_E = 29 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_IGMP_V3_IPv6_E = 30 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_DECAP_RULES_IPv4_E = 31 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_DECAP_RULES_IPv6_E = 32 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_RULES_TWO_KEY_BLOCK_E = 33 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_RULES_FOUR_KEY_BLOCK_E = 34 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_RULES_SIX_KEY_BLOCK_E = 35 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIF_COUNTER_BASIC_E = 36 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIF_COUNTER_MIXED_E = 37 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIF_COUNTER_ENHANCED_E = 38 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FLOW_COUNTER_E = 39 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_GROUPS_E = 40 */
        {SWITCH_IB_ACL_GROUPS_NUM_MIN,
         SWITCH_IB_ACL_GROUPS_NUM_MAX,
         SWITCH_IB_ACL_GROUPS_HW_ENTRY_COST,
         SWITCH_IB_ACL_GROUPS_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_INTERNAL_E = 41 Divider between int & ext*/
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_RULES_E = 42 */
        {SWITCH_IB_ACL_RULES_NUM_MIN,
         SWITCH_IB_ACL_RULES_NUM_MAX,
         SWITCH_IB_ACL_RULES_HW_ENTRY_COST,
         SWITCH_IB_ACL_RULES_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_DECAP_RULES_E = 43 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_IGMP_V3_E = 44 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_A_TCAM_ONE_KEY_BLOCK_E = 45 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_A_TCAM_TWO_KEYS_BLOCK_E = 46 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_A_TCAM_FOUR_KEYS_BLOCK_E = 47 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_A_TCAM_SIX_KEYS_BLOCK_E = 48 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FCF_FORWORDING_E = 49 */
        {SWITCH_IB_FCF_RULES_MAX,
         SWITCH_IB_FCF_RULES_MAX,
         SWITCH_IB_FCF_FORWORDING_HW_ENTRY_COST,
         SWITCH_IB_FCF_FORWORDING_HW_TABLE_TYPE,
         SWITCH_IB_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_RMID_MANAGER_E = 50 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_NVE_MC_LIST_E = 51 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_SMID_MANAGER_E = 52 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV4_MC_SYSTEM_E = 53 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV6_MC_SYSTEM_E = 54 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIF_COUNTER_E = 55 */
        {0, 0, 0, 0, SWITCH_IB_INVALID_SW_TABLE_TYPE, FALSE},
    },

    {
        {TRUE, SWITCH_IB_TOTAL_TCAM},
        {FALSE, 0},
        {FALSE, 0},
        {FALSE, 0},
        {TRUE, SWITCH_IB_ROUTER_ADJ_MAX},
        {TRUE, SWITCH_IB_TOTAL_L3_REPLICATION_MATRIX},
        {TRUE, SWITCH_IB_ACL_GROUPS_NUM_MAX},
        {FALSE, 0},
        {FALSE, 0},
        {FALSE, 0},
    },

    /*16*/
    SWITCHX_IB_CNTR_BANK_PAIRS,
    SWITCHX_IB_CNTR_LINES_PER_BANK,
    SWITCHX_IB_CNTR_LINES_FLOW_PKT,
    SWITCHX_IB_CNTR_TYPE_FLOW_PKT,
    SWITCHX_IB_CNTR_LINES_FLOW_BYTE,
    SWITCHX_IB_CNTR_TYPE_FLOW_BYTE,
    SWITCHX_IB_CNTR_LINES_FLOW_BOTH,
    SWITCHX_IB_CNTR_TYPE_FLOW_BOTH,
    SWITCHX_IB_CNTR_LINES_RIF_BASIC,
    SWITCHX_IB_CNTR_TYPE_RIF_BASIC,
    SWITCHX_IB_CNTR_LINES_RIF_MIXED_1,
    SWITCHX_IB_CNTR_TYPE_RIF_MIXED_1,
    SWITCHX_IB_CNTR_LINES_RIF_MIXED_2,
    SWITCHX_IB_CNTR_TYPE_RIF_MIXED_2,
    SWITCHX_IB_CNTR_LINES_RIF_ENHANCED,
    SWITCHX_IB_CNTR_TYPE_RIF_ENHANCED,

    /*10*/
    SWITCH_IB_IB_PKEYS_TABLE_SIZE,


    SWITCH_IB_IB_ROUTER_LIDS_MAX,
    SWITCH_IB_IB_ROUTER_MC_LIDS_NUM_MAX,
    SWITCH_IB_IB_ROUTER_UC_LID_NUM_MAX,

    /*1*/
    SWITCH_IB_IB_PORTS_MAX,

    /*5*/
    SWITCHX_IB_NUM_HW_CPU_INGRESS_TCLASS_MAX,
    SWITCHX_IB_NUM_HW_DR_PATHS_MAX,
    SWITCHX_IB_NUM_HW_TRAP_GROUPS_MAX,
    SWITCHX_IB_TRAP_GROUP_PRIORITY_MIN,
    SWITCHX_IB_TRAP_GROUP_PRIORITY_MAX,
    SWITCHX_IB_NUM_RDQS_MAX,
    SWITCHX_IB_NUM_CPU_TCLASS,

    /* Tunnel */
    SWITCH_IB_NUM_MAX_TUNNEL_IPINIP,
    SWITCH_IB_NUM_MAX_TUNNEL_NVE,
    SWITCH_IB_TUNNEL_NVE_GS_FLOOD_MAX,
    SWITCH_IB_TUNNEL_NVE_GS_MC_MAX,
    SWITCH_IB_TUNNEL_TNUMT_IPV6_RECORDS_MAX,

    /* IGMP V3 */
    SWITCH_IB_IGMP_V3_NUM_MAX_ENTRIES,

    /* Telemetry */
    SWITCH_IB_TELE_HISTOGRAM_NUM_MAX,
    SWITCH_IB_TELE_HISTOGRAM_QUEUE_DEPTH_BINS,
    SWITCH_IB_TELE_HISTOGRAM_SAMPLE_TIME_RESOLUTION_MAX,
    SWITCH_IB_TELE_HISTOGRAM_BIN_SIZE_RESOLUTION_MIN,
    SWITCH_IB_TELE_HISTOGRAM_BIN_SIZE_RESOLUTION_MAX,
    SWITCH_IB_TELE_HISTOGRAM_DATA_BIN_BITS_MAX,
    SWITCH_IB_TELE_HISTOGRAM_MIN_BOUNDARY_MIN,
    SWITCH_IB_TELE_THRESHOLD_THR_MAX,
};
/************************************************
 *  Function declarations
 ***********************************************/


#endif /*__SWITCH_IB_H__*/
