/*
 *  Copyright (C) 2010-2018. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */

#ifndef __SWITCHX_A2_H__
#define __SWITCHX_A2_H__

#include <resource_manager/resource_manager.h>

/************************************************
 *  Local Defines
 ***********************************************/

/************************************************
 *  Local Macros
 ***********************************************/

/************************************************
 *  Local Type definitions
 ***********************************************/

/************************************************
 *  Defines
 ***********************************************/

#define SWITCHX_A2_ACL_INGRESS_GROUPS_MAX 95
#define SWITCHX_A2_ACL_ENGRESS_GROUPS_MAX 31
#define SWITCHX_A2_ACL_GROUPS_SIZE_MAX    16
#define SWITCHX_A2_ACL_GROUPS_NUM_MIN     0
#define SWITCHX_A2_ACL_GROUPS_NUM_MAX     128
#define SWITCHX_A2_ACL_RULES_BLOCK_MAX    20
#define SWITCHX_A2_ACL_RULES_NUM_MIN      0
#define SWITCHX_A2_ACL_RULES_NUM_MAX      UNLIMITED_SDK_TABLE_SIZE
#define SWITCHX_A2_ACL_PBS_ENTRIES_MAX    0xc000
#define SWITCHX_A2_ACL_PBS_ENTRIES_MIN    0
#define SWITCHX_A2_ACL_PORT_RANGES_MAX    16
#define SWITCHX_A2_ACL_REGIONS_MAX        400
#define SWITCHX_A2_ACL_INGRESS_TABLES_MAX 512
#define SWITCHX_A2_ACL_EGRESS_TABLES_MAX  128
#define SWITCHX_A2_ACL_TABLES_MAX        \
    (SWITCHX_A2_ACL_INGRESS_TABLES_MAX + \
     SWITCHX_A2_ACL_EGRESS_TABLES_MAX)
#define SWITCHX_A2_ACL_VLAN_GROUPS_MAX                          512
#define SWITCHX_A2_ACL_TRAP_GROUPS_MAX                          3
#define SWITCHX_A2_ACL_MAX_FLEX_KEYS                            0
#define SWITCHX_A2_ACL_MAX_ACTIONS_PER_RULE                     0
#define SWITCHX_A2_ACL_MAX_ACTIONS_PER_SET                      0
#define SWITCHX_A2_ACL_EXTENDED_ACTIONS_NUM_MIN                 0
#define SWITCHX_A2_ACL_EXTENDED_ACTIONS_NUM_MAX                 0
#define SWITCHX_A2_ACL_PARSING_DEPTH                            0
#define SWITCHX_A2_ACL_CUSTOM_BYTES_SET_MAX                     0
#define SWITCHX_A2_ACL_CUSTOM_BYTES_SET_SIZE_MAX                0
#define SWITCHX_A2_ACL_CUSTOM_BYTES_EXTRACTION_POINT_OFFSET_MAX 0
#define SWITCHX_A2_ACL_PBILM_ENTRIES_MAX                        0

#define SWITCHX_A2_ROUTER_RIFS_MAX                      254
#define SWITCHX_A2_ROUTER_RIFS_DONTCARE                 (SWITCHX_A2_ROUTER_RIFS_MAX + 1)
#define SWITCHX_A2_ROUTER_SUB_PORT_FID_START_INDEX      0
#define SWITCHX_A2_ROUTER_IPV4_UC_MAX                   0x3000    /*12k*/
#define SWITCHX_A2_ROUTER_IPV4_MC_MAX                   0x3000    /*12k*/
#define SWITCHX_A2_ROUTER_IPV6_UC_MAX                   0x1800    /*6k*/
#define SWITCHX_A2_ROUTER_IPV6_MC_MAX                   0x1800    /*6k*/
#define SWITCHX_A2_ROUTER_ECMP_MAX                      64
#define SWITCHX_A2_ROUTER_ECMP_HASH_MAX                 127
#define SWITCHX_A2_ROUTER_NEIGHS_MAX                    0x2000    /*8K*/
#define SWITCHX_A2_ROUTER_ADJ_MAX                       0x2000    /*8k*/
#define SWITCHX_A2_ROUTER_VRID_MAX                      254
#define SWITCHX_A2_ROUTER_COUNTERS_ID_MAX               23
#define SWITCHX_A2_ROUTER_NEXT_HOP_MAX                  64
#define SWITCHX_A2_ROUTER_ECMP_CONTAINER_TOT_WEIGHT_MAX 0
#define SWITCHX_A2_SHSPM_TREE_MAX                       0
#define SWITCHX_A2_SHSPM_ENTRY_MAX                      0
#define SWITCHX_A2_MC_RPF_GROUP_MAX                     0

#define SWITCHX_A2_IB_ROUTER_LIDS_MAX        49152
#define SWITCHX_A2_IB_ROUTER_MC_LIDS_NUM_MAX 0x4000   /*16k*/
#define SWITCHX_A2_IB_ROUTER_UC_LID_NUM_MAX  0xc000   /*48k*/
#define SWITCHX_A2_IB_PKEYS_TABLE_SIZE       1000

#define SWITCHX_A2_FCF_PORT_DENSITY_MAX 24
#define SWITCHX_A2_FCF_ZONES_PAIRS_MAX  0x9000
#define SWITCHX_A2_FCF_ZONES_GROUPS_MAX 0x3000
#define SWITCHX_A2_FCF_GATEWAY_MAX      0x2000
#define SWITCHX_A2_FCF_RULES_MAX        7999

#define SWITCHX_A2_PORT_LCL_NUM_MAX             68
#define SWITCHX_A2_PORT_EXT_NUM_MAX             64
#define SWITCHX_A2_PORT_LOG_NUM_MAX             4096
#define SWITCHX_A2_PORT_MTU_MAX                 10000
#define SWITCHX_A2_PORT_MTU_MIN                 68
#define SWITCHX_A2_PORT_STORM_CONTROL_ID_MAX    4
#define SWITCHX_A2_PORT_VEPA_CHANNELS_NUM_MAX   0
#define SWITCHX_A2_PORT_SYSTEM_PORTS_MAX        48000
#define SWITCHX_A2_PORT_SYSTEM_PORT_MODULES_MAX 64
#define SWITCHX_A2_IB_PORTS_MAX                 36

#define SWITCHX_A2_LAG_NUM_MAX          64
#define SWITCHX_A2_LAG_PORT_MEMBERS_MAX 16
#define SWITCHX_A2_LAG_VECTORS_NUM_MAX  0

#define SWITCHX_A2_SPAN_SESSION_ID_MAX 6

#define SWITCHX_A2_FDB_MID_MAX         7000
#define SWITCHX_A2_FDB_MID_START_INDEX 0xC000
#define SWITCHX_A2_FDB_PGT_MAX         0
#define SWITCHX_A2_FDB_UC_ADDRESS_MAX  0xc000                  /*48k*/
#define SWITCHX_A2_FDB_MC_ADDRESS_MAX  0x4000                  /*16k*/

#define SWITCHX_A2_FLOODING_TABLE_MAX         2
#define SWITCHX_A2_FLOODING_TABLE_PER_VID_MAX 1

#define SWITCHX_A2_SWID_ID_MAX 7

#define SWITCHX_A2_POLICER_POOL_SIZE               0
#define SWITCHX_A2_POLICER_HOST_IFC_POOL_SIZE      0
#define SWITCHX_A2_POLICER_STORM_CONTROL_POOL_SIZE 0
#define SWITCHX_A2_POLICER_BS_MIN_VALUE_PACKETS    0
#define SWITCHX_A2_POLICER_BS_MIN_VALUE_BYTES      0
#define SWITCHX_A2_POLICER_BS_MAX_VALUE            0

#define SWITCHX_A2_COS_TRAFFIC_CLASS_MAX             7
#define SWITCHX_A2_COS_PORT_ETS_SUB_GROUP_MAX        0
#define SWITCHX_A2_COS_PORT_ETS_GROUP_MAX            0
#define SWITCHX_A2_COS_PORT_PRIO_MAX                 7
#define SWITCHX_A2_COS_PORT_COLOR_MAX                0
#define SWITCHX_A2_COS_PORT_ETS_ELEMENTS_NUM         0
#define SWITCHX_A2_COS_BUFFER_64K_SIZE_MAX           63.703125
#define SWITCHX_A2_COS_BUFFER_128K_SIZE_MAX          127.828125
#define SWITCHX_A2_COS_REDECN_DEFAULT_AQS_WEIGHT     0
#define SWITCHX_A2_COS_REDECN_RED_DROP_ENABLED       FALSE
#define SWITCHX_A2_COS_REDECN_SCD                    FALSE
#define SWITCHX_A2_COS_REDECN_PROFILES_MAX           0
#define SWITCHX_A2_COS_REDECN_CELL_MULTIPLIER        0
#define SWITCHX_A2_COS_REDECN_DEFAULT_TC_RED_ENABLED FALSE
#define SWITCHX_A2_COS_REDECN_DEFAULT_TC_ECN_ENABLED FALSE
#define SWITCH_A2_BRIDGE_NUM_MAX                     512

#define SWITCHX_A2_TOTAL_TCAM                  0x3000
#define SWITCHX_A2_TOTAL_L3_REPLICATION_MATRIX 0x3000

/*SW TABLE -> HW TABLE MAPPING */

#define SWITCHX_A2_FDB_UC_MAC_HW_TABLE_TYPE /*sfd*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCHX_A2_FDB_MC_MAC_HW_TABLE_TYPE /*sfd*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCHX_A2_ROUTER_IPV4_UC_HW_TABLE_TYPE/*ruft*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCHX_A2_ROUTER_IPV6_UC_HW_TABLE_TYPE/*ruft*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCHX_A2_ROUTER_IPV4_MC_HW_TABLE_TYPE/*rmft*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCHX_A2_ROUTER_IPV6_MC_HW_TABLE_TYPE/*rmft*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCHX_A2_ROUTER_ARP_IPV4_HW_TABLE_TYPE/*ruht*/ RM_HW_TABLE_TYPE_TCAM_E
#define SWITCHX_A2_ROUTER_ARP_IPV6_HW_TABLE_TYPE/*ruht*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCHX_A2_ROUTER_MC_REPLICATIONS_HW_TABLE_TYPE/*rigr*/ RM_HW_TABLE_TYPE_REPLICATION_MATRIX_E

#define SWITCHX_A2_ROUTER_ADJACENCY_HW_TABLE_TYPE/*ratr*/ RM_HW_TABLE_TYPE_ADJACENCY_E

#define SWITCHX_A2_L2_MC_MIDS_HW_TABLE_TYPE/*smid*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCHX_A2_LAG_VECTORS_HW_TABLE_TYPE/*sldr*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCHX_A2_L2_MC_FLOODING_HW_TABLE_TYPE/*sftr*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCHX_A2_FCF_FORWORDING_HW_TABLE_TYPE/*fftr*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCHX_A2_ACL_RULES_HW_TABLE_TYPE /*ptce*/ RM_HW_TABLE_TYPE_TCAM_E

#define SWITCHX_A2_ACL_GROUPS_HW_TABLE_TYPE           RM_HW_TABLE_TYPE_ACL_GROUP_TABLE_E
#define SWITCHX_A2_ACL_EXTENDED_ACTIONS_HW_TABLE_TYPE RM_HW_TABLE_TYPE_INVALID
#define SWITCHX_A2_ACL_PBS_HW_TABLE_TYPE              RM_HW_TABLE_TYPE_KVD_LINEAR_E


/*phy_entry_cost per table */

#define SWITCHX_A2_FDB_UC_MAC_HW_ENTRY_COST 1
#define SWITCHX_A2_FDB_MC_MAC_HW_ENTRY_COST 1

#define SWITCHX_A2_ROUTER_IPV4_UC_HW_ENTRY_COST/*ruft*/ 1
#define SWITCHX_A2_ROUTER_IPV6_UC_HW_ENTRY_COST/*ruft*/ 1
#define SWITCHX_A2_ROUTER_IPV4_MC_HW_ENTRY_COST/*rmft*/ 1
#define SWITCHX_A2_ROUTER_IPV6_MC_HW_ENTRY_COST/*rmft*/ 1

#define SWITCHX_A2_ROUTER_ARP_IPV4_HW_ENTRY_COST/*ruft*/ 1
#define SWITCHX_A2_ROUTER_ARP_IPV6_HW_ENTRY_COST/*ruft*/ 1

#define SWITCHX_A2_ROUTER_MC_REPLICATIONS_HW_ENTRY_COST/*rigr*/ 1

#define SWITCHX_A2_ROUTER_ADJACENCY_HW_ENTRY_COST/*ratr*/ 1

#define SWITCHX_A2_L2_MC_MIDS_HW_ENTRY_COST/*smid*/ 1

#define SWITCHX_A2_LAG_VECTORS_ENTRY_COST 1

#define SWITCHX_A2_L2_MC_FLOODING_HW_ENTRY_COST/*sftr*/ 1

#define SWITCHX_A2_FCF_FORWORDING_HW_ENTRY_COST/*fftr*/ 1

#define SWITCHX_A2_ACL_RULES_HW_ENTRY_COST /*ptce*/ 1

#define SWITCHX_A2_ACL_GROUPS_HW_ENTRY_COST           1
#define SWITCHX_A2_ACL_EXTENDED_ACTIONS_HW_ENTRY_COST 0
#define SWITCHX_A2_ACL_PBS_HW_ENTRY_COST              1

#define SWITCHX_A2_BUFFERS_TOTAL_MEMORY            0
#define SWITCHX_A2_DESCRIPTOR_BUFFERS_TOTAL_MEMORY 0
#define SWITCH_A2_MAX_TOTAL_HEADROOM_SIZE          0
#define SWITCHX_A2_HEADROOM_NUM_BUFF_PER_PORT      10
/* Shared buffers - Condor */
#define SWITCHX_A2_SHARED_BUFF_NUM_ING_POOL_PER_PORT  0
#define SWITCHX_A2_SHARED_BUFF_NUM_EGR_POOL_PER_PORT  0
#define SWITCHX_A2_SHARED_BUFF_NUM_MC_POOL_PER_PORT   0
#define SWITCHX_A2_SHARED_BUFF_NUM_ING_DESC_PER_PORT  0
#define SWITCHX_A2_SHARED_BUFF_NUM_EGR_DESC_PER_PORT  0
#define SWITCHX_A2_SHARED_BUFF_NUM_MANAGMENT_POOL     0
#define SWITCHX_A2_SHARED_BUFF_TOTAL_NUM_POOL         0
#define SWITCHX_A2_SHARED_BUFF_NUM_EGR_BUFF_PER_PORT  0
#define SWITCHX_A2_SHARED_BUFF_NUM_ING_BUFF_PER_PORT  0
#define SWITCHX_A2_SHARED_BUFF_MAX_POOL_SIZE          0
#define SWITCHX_A2_SHARED_BUFF_PORT_NUM_MAX           0
#define SWITCHX_A2_SHARED_BUFF_TCLASS_NUM_MAX         0
#define SWITCHX_A2_SHARED_BUFF_RET_STATISTICS_NUM_MAX 0
#define SWITCHX_A2_BUFF_UNIT_SIZE                     72
#define SWITCHX_A2_SHARED_BUFF_MC_MAX_NUM_PRIO        0


#define SWITCHX_A2_KVD_SIZE                      0
#define SWITCHX_A2_NUM_HW_CPU_INGRESS_TCLASS_MAX 14
#define SWITCHX_A2_NUM_HW_DR_PATHS_MAX           0
#define SWITCHX_A2_NUM_HW_TRAP_GROUPS_MAX        5
#define SWITCHX_A2_TRAP_GROUP_PRIORITY_MIN       0
#define SWITCHX_A2_TRAP_GROUP_PRIORITY_MAX       4
#define SWITCHX_A2_NUM_RDQS_MAX                  24
#define SWITCHX_A2_NUM_CPU_TCLASS                12
#define SWITCHX_A2_KVD_HASH_SINGLE_MIN_SIZE      0
#define SWITCHX_A2_KVD_HASH_DOUBLE_MIN_SIZE      0
#define SWITCHX_A2_KVD_GUARANTEED_CAPACITY       0
#define SWITCHX_A2_KVD_LINEAR_VIRTUAL_TABLE_SIZE 0

#define SWITCHX_A2_PGT_SIZE  0
#define SWITCHX_A2_RMPE_SIZE 0

/* SW Counter Allocation - Only used on some chips */
#define SWITCHX_A2_CNTR_BANK_PAIRS         0
#define SWITCHX_A2_CNTR_LINES_PER_BANK     0
#define SWITCHX_A2_CNTR_LINES_FLOW_PKT     0
#define SWITCHX_A2_CNTR_TYPE_FLOW_PKT      0
#define SWITCHX_A2_CNTR_LINES_FLOW_BYTE    0
#define SWITCHX_A2_CNTR_TYPE_FLOW_BYTE     0
#define SWITCHX_A2_CNTR_LINES_FLOW_BOTH    0
#define SWITCHX_A2_CNTR_TYPE_FLOW_BOTH     0
#define SWITCHX_A2_CNTR_LINES_RIF_BASIC    0
#define SWITCHX_A2_CNTR_TYPE_RIF_BASIC     0
#define SWITCHX_A2_CNTR_LINES_RIF_MIXED_1  0
#define SWITCHX_A2_CNTR_TYPE_RIF_MIXED_1   0
#define SWITCHX_A2_CNTR_LINES_RIF_MIXED_2  0
#define SWITCHX_A2_CNTR_TYPE_RIF_MIXED_2   0
#define SWITCHX_A2_CNTR_LINES_RIF_ENHANCED 0
#define SWITCHX_A2_CNTR_TYPE_RIF_ENHANCED  0

/* Tunnel */
#define SWITCHX_A2_NUM_MAX_TUNNEL_IPINIP         0      /* Not supported */
#define SWITCHX_A2_NUM_MAX_TUNNEL_NVE            0      /* Not supported */
#define SWITCHX_A2_TUNNEL_NVE_GS_FLOOD_MAX       0      /* Not supported */
#define SWITCHX_A2_TUNNEL_NVE_GS_MC_MAX          0 /* Not supported */
#define SWITCHX_A2_TUNNEL_TNUMT_IPV6_RECORDS_MAX 0      /* Not supported */

/* IGMP V3 */
#define SWITCHX_A2_IGMP_V3_NUM_MAX_ENTRIES 0      /* Not supported */

/* Telemetry */
#define SWITCHX_A2_TELE_HISTOGRAM_NUM_MAX                    0
#define SWITCHX_A2_TELE_HISTOGRAM_QUEUE_DEPTH_BINS           0
#define SWITCHX_A2_TELE_HISTOGRAM_SAMPLE_TIME_RESOLUTION_MAX 0
#define SWITCHX_A2_TELE_HISTOGRAM_BIN_SIZE_RESOLUTION_MIN    0
#define SWITCHX_A2_TELE_HISTOGRAM_BIN_SIZE_RESOLUTION_MAX    0
#define SWITCHX_A2_TELE_HISTOGRAM_DATA_BIN_BITS_MAX          0
#define SWITCHX_A2_TELE_HISTOGRAM_MIN_BOUNDARY_MIN           0
#define SWITCHX_A2_TELE_THRESHOLD_THR_MAX                    0

#define SWITCHX_A2_INVALID_SW_TABLE_TYPE RM_SDK_TABLE_TYPE_INVALID_E
/************************************************
 *  Macros
 ***********************************************/

/************************************************
 *  Type definitions
 ***********************************************/

/************************************************
 *  Global variables
 ***********************************************/

static const rm_resources_t rm_resource_switchx_a2 = {
    /*13*/
    SWITCHX_A2_ACL_INGRESS_GROUPS_MAX,
    SWITCHX_A2_ACL_ENGRESS_GROUPS_MAX,
    SWITCHX_A2_ACL_GROUPS_SIZE_MAX,
    SWITCHX_A2_ACL_GROUPS_NUM_MAX,
    SWITCHX_A2_ACL_RULES_BLOCK_MAX,
    SWITCHX_A2_ACL_PBS_ENTRIES_MAX,
    SWITCHX_A2_ACL_PORT_RANGES_MAX,
    SWITCHX_A2_ACL_REGIONS_MAX,
    SWITCHX_A2_ACL_INGRESS_TABLES_MAX,
    SWITCHX_A2_ACL_EGRESS_TABLES_MAX,
    SWITCHX_A2_ACL_TABLES_MAX,
    SWITCHX_A2_ACL_VLAN_GROUPS_MAX,
    SWITCHX_A2_ACL_TRAP_GROUPS_MAX,
    SWITCHX_A2_ACL_MAX_FLEX_KEYS,
    SWITCHX_A2_ACL_MAX_ACTIONS_PER_RULE,
    SWITCHX_A2_ACL_MAX_ACTIONS_PER_SET,
    SWITCHX_A2_ACL_PARSING_DEPTH,
    SWITCHX_A2_ACL_CUSTOM_BYTES_SET_MAX,
    SWITCHX_A2_ACL_CUSTOM_BYTES_SET_SIZE_MAX,
    SWITCHX_A2_ACL_CUSTOM_BYTES_EXTRACTION_POINT_OFFSET_MAX,
    SWITCHX_A2_ACL_PBILM_ENTRIES_MAX,

    /*26*/
    SWITCHX_A2_ROUTER_RIFS_MAX,
    SWITCHX_A2_ROUTER_RIFS_DONTCARE,
    SWITCHX_A2_ROUTER_SUB_PORT_FID_START_INDEX,
    SWITCHX_A2_ROUTER_IPV4_UC_MAX,
    SWITCHX_A2_ROUTER_IPV4_MC_MAX,
    SWITCHX_A2_ROUTER_IPV6_UC_MAX,
    SWITCHX_A2_ROUTER_IPV6_MC_MAX,
    SWITCHX_A2_ROUTER_ECMP_MAX,
    SWITCHX_A2_ROUTER_ECMP_HASH_MAX,
    SWITCHX_A2_ROUTER_ADJ_MAX,
    SWITCHX_A2_ROUTER_NEIGHS_MAX,
    SWITCHX_A2_ROUTER_VRID_MAX,
    SWITCHX_A2_ROUTER_COUNTERS_ID_MAX,
    SWITCHX_A2_ROUTER_NEXT_HOP_MAX,
    SWITCHX_A2_ROUTER_ECMP_CONTAINER_TOT_WEIGHT_MAX,
    SWITCHX_A2_SHSPM_TREE_MAX,
    SWITCHX_A2_SHSPM_ENTRY_MAX,
    SWITCHX_A2_MC_RPF_GROUP_MAX,

    /*5*/
    SWITCHX_A2_FCF_PORT_DENSITY_MAX,
    SWITCHX_A2_FCF_ZONES_PAIRS_MAX,
    SWITCHX_A2_FCF_ZONES_GROUPS_MAX,
    SWITCHX_A2_FCF_GATEWAY_MAX,
    SWITCHX_A2_FCF_RULES_MAX,

    /*8*/
    SWITCHX_A2_PORT_LCL_NUM_MAX,
    SWITCHX_A2_PORT_EXT_NUM_MAX,
    SWITCHX_A2_PORT_LOG_NUM_MAX,
    SWITCHX_A2_PORT_MTU_MAX,
    SWITCHX_A2_PORT_MTU_MIN,
    SWITCHX_A2_PORT_STORM_CONTROL_ID_MAX,
    SWITCHX_A2_PORT_VEPA_CHANNELS_NUM_MAX,
    SWITCHX_A2_PORT_SYSTEM_PORTS_MAX,
    SWITCHX_A2_PORT_SYSTEM_PORT_MODULES_MAX,

    /*6*/
    SWITCHX_A2_LAG_NUM_MAX,
    SWITCHX_A2_LAG_PORT_MEMBERS_MAX,

    SWITCHX_A2_SPAN_SESSION_ID_MAX,
    SWITCHX_A2_SPAN_SESSION_ID_MAX,

    SWITCHX_A2_FDB_MID_MAX,
    SWITCHX_A2_FDB_MID_START_INDEX,
    SWITCHX_A2_FDB_PGT_MAX,
    SWITCHX_A2_FDB_UC_ADDRESS_MAX,
    SWITCHX_A2_FDB_MC_ADDRESS_MAX,

    SWITCHX_A2_FLOODING_TABLE_MAX,
    SWITCHX_A2_FLOODING_TABLE_PER_VID_MAX,

    SWITCHX_A2_COS_TRAFFIC_CLASS_MAX,
    SWITCHX_A2_COS_PORT_ETS_SUB_GROUP_MAX,
    SWITCHX_A2_COS_PORT_ETS_GROUP_MAX,
    SWITCHX_A2_COS_PORT_PRIO_MAX,
    SWITCHX_A2_COS_PORT_COLOR_MAX,
    SWITCHX_A2_COS_PORT_ETS_ELEMENTS_NUM,
    SWITCHX_A2_COS_BUFFER_64K_SIZE_MAX,
    SWITCHX_A2_COS_BUFFER_128K_SIZE_MAX,
    SWITCHX_A2_COS_REDECN_DEFAULT_AQS_WEIGHT,
    SWITCHX_A2_COS_REDECN_RED_DROP_ENABLED,
    SWITCHX_A2_COS_REDECN_SCD,
    SWITCHX_A2_COS_REDECN_PROFILES_MAX,
    SWITCHX_A2_COS_REDECN_CELL_MULTIPLIER,
    SWITCHX_A2_COS_REDECN_DEFAULT_TC_RED_ENABLED,
    SWITCHX_A2_COS_REDECN_DEFAULT_TC_ECN_ENABLED,
    SWITCHX_A2_SWID_ID_MAX,

    SWITCHX_A2_POLICER_POOL_SIZE,
    SWITCHX_A2_POLICER_HOST_IFC_POOL_SIZE,
    SWITCHX_A2_POLICER_STORM_CONTROL_POOL_SIZE,
    SWITCHX_A2_POLICER_BS_MIN_VALUE_PACKETS,
    SWITCHX_A2_POLICER_BS_MIN_VALUE_BYTES,
    SWITCHX_A2_POLICER_BS_MAX_VALUE,
    SWITCHX_A2_KVD_SIZE,
    SWITCHX_A2_KVD_HASH_SINGLE_MIN_SIZE,
    SWITCHX_A2_KVD_HASH_DOUBLE_MIN_SIZE,
    SWITCHX_A2_KVD_GUARANTEED_CAPACITY,
    SWITCHX_A2_KVD_LINEAR_VIRTUAL_TABLE_SIZE,

    SWITCHX_A2_PGT_SIZE,
    SWITCHX_A2_RMPE_SIZE,

    SWITCH_A2_BRIDGE_NUM_MAX,

    SWITCHX_A2_BUFFERS_TOTAL_MEMORY,
    SWITCHX_A2_DESCRIPTOR_BUFFERS_TOTAL_MEMORY,
    SWITCH_A2_MAX_TOTAL_HEADROOM_SIZE,
    SWITCHX_A2_HEADROOM_NUM_BUFF_PER_PORT,
    /* Shared buffers - Condor */
    SWITCHX_A2_SHARED_BUFF_NUM_ING_POOL_PER_PORT,
    SWITCHX_A2_SHARED_BUFF_NUM_EGR_POOL_PER_PORT,
    SWITCHX_A2_SHARED_BUFF_NUM_MC_POOL_PER_PORT,
    SWITCHX_A2_SHARED_BUFF_NUM_ING_DESC_PER_PORT,
    SWITCHX_A2_SHARED_BUFF_NUM_EGR_DESC_PER_PORT,
    SWITCHX_A2_SHARED_BUFF_NUM_MANAGMENT_POOL,
    SWITCHX_A2_SHARED_BUFF_TOTAL_NUM_POOL,
    SWITCHX_A2_SHARED_BUFF_NUM_EGR_BUFF_PER_PORT,
    SWITCHX_A2_SHARED_BUFF_NUM_ING_BUFF_PER_PORT,
    SWITCHX_A2_SHARED_BUFF_MAX_POOL_SIZE,
    SWITCHX_A2_SHARED_BUFF_PORT_NUM_MAX,
    SWITCHX_A2_SHARED_BUFF_TCLASS_NUM_MAX,
    SWITCHX_A2_SHARED_BUFF_RET_STATISTICS_NUM_MAX,
    SWITCHX_A2_BUFF_UNIT_SIZE,
    SWITCHX_A2_SHARED_BUFF_MC_MAX_NUM_PRIO,

    {
        /* RM_SDK_TABLE_TYPE_UC_MAC_E = 0 */
        {SWITCHX_A2_FDB_UC_ADDRESS_MAX,
         SWITCHX_A2_FDB_UC_ADDRESS_MAX,
         SWITCHX_A2_FDB_UC_MAC_HW_ENTRY_COST,
         SWITCHX_A2_FDB_UC_MAC_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_MC_MAC_E = 1 */
        {SWITCHX_A2_FDB_MC_ADDRESS_MAX,
         SWITCHX_A2_FDB_MC_ADDRESS_MAX,
         SWITCHX_A2_FDB_MC_MAC_HW_ENTRY_COST,
         SWITCHX_A2_FDB_MC_MAC_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV4_UC_E = 2 */
        {SWITCHX_A2_ROUTER_IPV4_UC_MAX,
         SWITCHX_A2_ROUTER_IPV4_UC_MAX,
         SWITCHX_A2_ROUTER_IPV4_UC_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_IPV4_UC_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV6_UC_E = 3 */
        {SWITCHX_A2_ROUTER_IPV6_UC_MAX,
         SWITCHX_A2_ROUTER_IPV6_UC_MAX,
         SWITCHX_A2_ROUTER_IPV6_UC_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_IPV6_UC_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV4_MC_E = 4 */
        {SWITCHX_A2_ROUTER_IPV4_MC_MAX,
         SWITCHX_A2_ROUTER_IPV4_MC_MAX,
         SWITCHX_A2_ROUTER_IPV4_MC_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_IPV4_MC_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV6_MC_E = 5 */
        {SWITCHX_A2_ROUTER_IPV6_MC_MAX,
         SWITCHX_A2_ROUTER_IPV6_MC_MAX,
         SWITCHX_A2_ROUTER_IPV6_MC_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_IPV6_MC_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ARP_IPV4_E = 6 */
        {SWITCHX_A2_ROUTER_NEIGHS_MAX,
         SWITCHX_A2_ROUTER_NEIGHS_MAX,
         SWITCHX_A2_ROUTER_ARP_IPV4_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_ARP_IPV4_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ARP_IPV6_E = 7 */
        {SWITCHX_A2_ROUTER_NEIGHS_MAX,
         SWITCHX_A2_ROUTER_NEIGHS_MAX,
         SWITCHX_A2_ROUTER_ARP_IPV6_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_ARP_IPV6_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_L3_MC_REPLICATIONS_E = 8 */
        {SWITCHX_A2_TOTAL_L3_REPLICATION_MATRIX,
         SWITCHX_A2_TOTAL_L3_REPLICATION_MATRIX,
         SWITCHX_A2_ROUTER_MC_REPLICATIONS_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_MC_REPLICATIONS_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ADJACENCY_E = 9 */
        {SWITCHX_A2_ROUTER_ADJ_MAX,
         SWITCHX_A2_ROUTER_ADJ_MAX,
         SWITCHX_A2_ROUTER_ADJACENCY_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_ADJACENCY_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_L2_MC_VECTORS_E = 10 */
        {SWITCHX_A2_FDB_MID_MAX,
         SWITCHX_A2_FDB_MID_MAX,
         SWITCHX_A2_L2_MC_MIDS_HW_ENTRY_COST,
         SWITCHX_A2_L2_MC_MIDS_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_LAG_VECTORS_E = 11 */
        {SWITCHX_A2_LAG_VECTORS_NUM_MAX,
         SWITCHX_A2_LAG_VECTORS_NUM_MAX,
         SWITCHX_A2_LAG_VECTORS_ENTRY_COST,
         SWITCHX_A2_LAG_VECTORS_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_FLOOD_VECTORS_E = 12 */
        {SWITCHX_A2_FLOODING_TABLE_MAX,
         SWITCHX_A2_FLOODING_TABLE_MAX,
         SWITCHX_A2_L2_MC_FLOODING_HW_ENTRY_COST,
         SWITCHX_A2_L2_MC_FLOODING_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},


        /* RM_SDK_TABLE_TYPE_ACL_EXTENDED_ACTIONS_E = 13 */
        {SWITCHX_A2_ACL_EXTENDED_ACTIONS_NUM_MIN,
         SWITCHX_A2_ACL_EXTENDED_ACTIONS_NUM_MAX,
         SWITCHX_A2_ACL_EXTENDED_ACTIONS_HW_ENTRY_COST,
         SWITCHX_A2_ACL_EXTENDED_ACTIONS_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_PBS_E = 14 */
        {SWITCHX_A2_ACL_PBS_ENTRIES_MIN,
         SWITCHX_A2_ACL_PBS_ENTRIES_MAX,
         SWITCHX_A2_ACL_PBS_HW_ENTRY_COST,
         SWITCHX_A2_ACL_PBS_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_ERIF_LIST_E = 15 */
        {SWITCHX_A2_ROUTER_ADJ_MAX,
         SWITCHX_A2_ROUTER_ADJ_MAX,
         SWITCHX_A2_ROUTER_ADJACENCY_HW_ENTRY_COST,
         SWITCHX_A2_ROUTER_ADJACENCY_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_TUNNEL_RTDP_E = 16 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},


        /* RM_SDK_TABLE_TYPE_ILM_E = 17 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RPF_GROUP_E = 18 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_VLAN_E = 19 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_VPORTS_E = 20 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FID_E = 21 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_VNI_E = 22 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_TUNNEL_IPV6_FDB_E = 23 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_MPLS_NHLFE_E = 24 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_PB_MPLS_ILM_E = 25 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_NVE_IPV6_LIST_E = 26 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_E = 27 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIPS_E = 28 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_IGMP_V3_IPv4_E = 29 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_IGMP_V3_IPv6_E = 30 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_DECAP_RULES_IPv4_E = 31 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_DECAP_RULES_IPv6_E = 32 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_RULES_TWO_KEY_BLOCK_E = 33 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_RULES_FOUR_KEY_BLOCK_E = 34 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_RULES_SIX_KEY_BLOCK_E = 35 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIF_COUNTER_BASIC_E = 36 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIF_COUNTER_MIXED_E = 37 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIF_COUNTER_ENHANCED_E = 38 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FLOW_COUNTER_E = 39 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_GROUPS_E = 40 */
        {SWITCHX_A2_ACL_GROUPS_NUM_MIN,
         SWITCHX_A2_ACL_GROUPS_NUM_MAX,
         SWITCHX_A2_ACL_GROUPS_HW_ENTRY_COST,
         SWITCHX_A2_ACL_GROUPS_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_INTERNAL_E = 41 Divider between int & ext*/
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_ACL_RULES_E = 42 */
        {SWITCHX_A2_ACL_RULES_NUM_MIN,
         SWITCHX_A2_ACL_RULES_NUM_MAX,
         SWITCHX_A2_ACL_RULES_HW_ENTRY_COST,
         SWITCHX_A2_ACL_RULES_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},


        /* RM_SDK_TABLE_TYPE_DECAP_RULES_E = 43 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_IGMP_V3_E = 44 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_A_TCAM_ONE_KEY_BLOCK_E = 45 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_A_TCAM_TWO_KEYS_BLOCK_E = 46 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_A_TCAM_FOUR_KEYS_BLOCK_E = 47 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_A_TCAM_SIX_KEYS_BLOCK_E = 48 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FCF_FORWORDING_E = 49 */
        {SWITCHX_A2_FCF_RULES_MAX,
         SWITCHX_A2_FCF_RULES_MAX,
         SWITCHX_A2_FCF_FORWORDING_HW_ENTRY_COST,
         SWITCHX_A2_FCF_FORWORDING_HW_TABLE_TYPE,
         SWITCHX_A2_INVALID_SW_TABLE_TYPE,
         FALSE},

        /* RM_SDK_TABLE_TYPE_RMID_MANAGER_E = 50 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_NVE_MC_LIST_E = 51 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_SMID_MANAGER_E = 52 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV4_MC_SYSTEM_E = 53 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_FIB_IPV6_MC_SYSTEM_E = 54 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},

        /* RM_SDK_TABLE_TYPE_RIF_COUNTER_E = 55 */
        {0, 0, 0, 0, SWITCHX_A2_INVALID_SW_TABLE_TYPE, FALSE},
    },

    {
        {TRUE, SWITCHX_A2_TOTAL_TCAM},
        {FALSE, 0},
        {FALSE, 0},
        {FALSE, 0},
        {TRUE, SWITCHX_A2_ROUTER_ADJ_MAX},
        {TRUE, SWITCHX_A2_TOTAL_L3_REPLICATION_MATRIX},
        {TRUE, SWITCHX_A2_ACL_GROUPS_NUM_MAX},
        {FALSE, 0},
        { FALSE, 0 },
        { FALSE, 0 },
    },

    /*16*/
    SWITCHX_A2_CNTR_BANK_PAIRS,
    SWITCHX_A2_CNTR_LINES_PER_BANK,
    SWITCHX_A2_CNTR_LINES_FLOW_PKT,
    SWITCHX_A2_CNTR_TYPE_FLOW_PKT,
    SWITCHX_A2_CNTR_LINES_FLOW_BYTE,
    SWITCHX_A2_CNTR_TYPE_FLOW_BYTE,
    SWITCHX_A2_CNTR_LINES_FLOW_BOTH,
    SWITCHX_A2_CNTR_TYPE_FLOW_BOTH,
    SWITCHX_A2_CNTR_LINES_RIF_BASIC,
    SWITCHX_A2_CNTR_TYPE_RIF_BASIC,
    SWITCHX_A2_CNTR_LINES_RIF_MIXED_1,
    SWITCHX_A2_CNTR_TYPE_RIF_MIXED_1,
    SWITCHX_A2_CNTR_LINES_RIF_MIXED_2,
    SWITCHX_A2_CNTR_TYPE_RIF_MIXED_2,
    SWITCHX_A2_CNTR_LINES_RIF_ENHANCED,
    SWITCHX_A2_CNTR_TYPE_RIF_ENHANCED,

    /*10*/
    SWITCHX_A2_IB_PKEYS_TABLE_SIZE,


    SWITCHX_A2_IB_ROUTER_LIDS_MAX,
    SWITCHX_A2_IB_ROUTER_MC_LIDS_NUM_MAX,
    SWITCHX_A2_IB_ROUTER_UC_LID_NUM_MAX,

    /*1*/
    SWITCHX_A2_IB_PORTS_MAX,

    /*5*/
    SWITCHX_A2_NUM_HW_CPU_INGRESS_TCLASS_MAX,
    SWITCHX_A2_NUM_HW_DR_PATHS_MAX,
    SWITCHX_A2_NUM_HW_TRAP_GROUPS_MAX,
    SWITCHX_A2_TRAP_GROUP_PRIORITY_MIN,
    SWITCHX_A2_TRAP_GROUP_PRIORITY_MAX,
    SWITCHX_A2_NUM_RDQS_MAX,
    SWITCHX_A2_NUM_CPU_TCLASS,

    /* Tunnel */
    SWITCHX_A2_NUM_MAX_TUNNEL_IPINIP,
    SWITCHX_A2_NUM_MAX_TUNNEL_NVE,
    SWITCHX_A2_TUNNEL_NVE_GS_FLOOD_MAX,
    SWITCHX_A2_TUNNEL_NVE_GS_MC_MAX,
    SWITCHX_A2_TUNNEL_TNUMT_IPV6_RECORDS_MAX,

    /* IGMP V3 */
    SWITCHX_A2_IGMP_V3_NUM_MAX_ENTRIES,

    /* Telemetry */
    SWITCHX_A2_TELE_HISTOGRAM_NUM_MAX,
    SWITCHX_A2_TELE_HISTOGRAM_QUEUE_DEPTH_BINS,
    SWITCHX_A2_TELE_HISTOGRAM_SAMPLE_TIME_RESOLUTION_MAX,
    SWITCHX_A2_TELE_HISTOGRAM_BIN_SIZE_RESOLUTION_MIN,
    SWITCHX_A2_TELE_HISTOGRAM_BIN_SIZE_RESOLUTION_MAX,
    SWITCHX_A2_TELE_HISTOGRAM_DATA_BIN_BITS_MAX,
    SWITCHX_A2_TELE_HISTOGRAM_MIN_BOUNDARY_MIN,
    SWITCHX_A2_TELE_THRESHOLD_THR_MAX,
};


/************************************************
 *  Function declarations
 ***********************************************/

#endif /*__SWITCHX_A2_H__*/
