/*
 *  Copyright (C) 2010-2018. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */


#ifndef __SX_MC_H__
#define __SX_MC_H__


/************************************************
 *  Type definitions
 ***********************************************/

/**
 * sx_mc_id_t
 * Primitive type - Used to note Multicast ID.
 */
typedef uint16_t sx_mc_id_t;

/************************************************
 *  Macro definitions
 ***********************************************/

/**
 * SX MC ID maximum/minimum values
 */
#define SX_MC_ID_MIN 0x1
#define SX_MC_ID_MAX 0xFFFF

#define SX_MC_ID_CHECK_RANGE(mc_id) SX_CHECK_MIN(SX_MC_ID_MIN, mc_id)

#endif  /* __SX_MC_H__ */
