/*
 *  Copyright (C) 2010-2018. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */


#ifndef __SX_MC_CONTAINER_ID_H__
#define __SX_MC_CONTAINER_ID_H__

/************************************************
 *  Type definitions
 ***********************************************/

/**
 *  * MC Container ID.
 *   */
typedef uint32_t sx_mc_container_id_t;

/**
 * SX_MC_CONTAINER_ID_INVALID defines an invalid MC container ID
 */
#define SX_MC_CONTAINER_ID_INVALID ((sx_mc_container_id_t)0)

#define SX_MC_CONTAINER_ID_CHECK_RANGE(MC_ID) \
    ((MC_ID) != SX_MC_CONTAINER_ID_INVALID)

#endif /* __SX_MC_CONTAINER_ID_H__ */
