/*
 *  Copyright (C) 2010-2018. Mellanox Technologies, Ltd. ALL RIGHTS RESERVED.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License"); you may
 *    not use this file except in compliance with the License. You may obtain
 *    a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 *    THIS CODE IS PROVIDED ON AN  *AS IS* BASIS, WITHOUT WARRANTIES OR
 *    CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT
 *    LIMITATION ANY IMPLIED WARRANTIES OR CONDITIONS OF TITLE, FITNESS
 *    FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT.
 *
 *    See the Apache Version 2.0 License for specific language governing
 *    permissions and limitations under the License.
 *
 */


#ifndef __SX_TYPES_H__
#define __SX_TYPES_H__

#include <sx/sdk/sx_access_cmd.h>
#include <sx/sdk/sx_acl.h>
#include <sx/sdk/sx_tunnel_id.h>
#include <sx/sdk/sx_bridge.h>
#include <sx/sdk/sx_check.h>
#include <sx/sdk/sx_cos.h>
#include <sx/sdk/sx_dev.h>
#include <sx/sdk/sx_event.h>
#include <sx/sdk/sx_event_id.h>
#include <sx/sdk/sx_fcf.h>
#include <sx/sdk/sx_fdb.h>
#include <sx/sdk/sx_flow_counter.h>
#include <sx/sdk/sx_host.h>
#include <sx/sdk/sx_ip.h>
#include <sx/sdk/sx_lag.h>
#include <sx/sdk/sx_mac.h>
#include <sx/sdk/sx_mc.h>
#include <sx/sdk/sx_mstp.h>
#include <sx/sdk/sx_policer.h>
#include <sx/sdk/sx_port.h>
#include <sx/sdk/sx_port_id.h>
#include <sx/sdk/sx_router.h>
#include <sx/sdk/sx_tunnel.h>
#include <sx/sdk/sx_mpls.h>
#include <sx/sdk/sx_mpls_ilm.h>
#include <sx/sdk/sx_mpls_next_hop.h>
#include <sx/sdk/sx_status.h>
#include <sx/sdk/sx_swid.h>
#include <sx/sdk/sx_topo.h>
#include <sx/sdk/sx_trap_id.h>
#include <sx/sdk/sx_vlan.h>
#include <sx/sdk/sx_span.h>
#include <sx/sdk/sx_rm.h>
#include <sx/sdk/sx_cos_redecn.h>
#include <sx/sdk/sx_mc_container.h>
#include <sx/sdk/sx_mc_container_id.h>
#include <sx/sdk/sx_tele.h>


/************************************************
 *  Type definitions
 ***********************************************/

/**
 * Bits array.
 */
typedef uint32_t sx_bmap_t;

typedef uint32_t length_t;

typedef uint8_t sx_stacking_tclass_t;
typedef uint8_t sx_cpu_tclass_t;
typedef uint8_t sx_rcv_rdq_t;

#endif /* __SX_TYPES_H__ */
