/*
 * Copyright (C) Mellanox Technologies, Ltd. 2010-2018 ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of Mellanox Technologies, Ltd.
 * (the "Company") and all right, title, and interest in and to the software product,
 * including all associated intellectual property rights, are and shall
 * remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef __SXD_EMAD_BUFFER_H__
#define __SXD_EMAD_BUFFER_H__

#include <complib/cl_qpool.h>

#include <sx/sxd/sxd_types.h>
#include <sx/sxd/kernel_user.h>

/************************************************
 *  Local Defines
 ***********************************************/

#define SXD_EMAD_BUFFER_MAX_SIZE (1518)


/************************************************
 *  Local Macros
 ***********************************************/

/************************************************
 *  Local Type definitions
 ***********************************************/

/************************************************
 *  Macros
 ***********************************************/

/************************************************
 *  Type definitions
 ***********************************************/

/**
 * sxd_emad_buff_t structure is used to store emad buffer.
 */
typedef struct sxd_emad_buff {
    cl_pool_item_t  pool_item;
    struct isx_meta meta;
    uint8_t         buff[SXD_EMAD_BUFFER_MAX_SIZE];
    uint32_t        size;
} sxd_emad_buff_t;

/************************************************
 *  Global variables
 ***********************************************/

/************************************************
 *  Function declarations
 ***********************************************/


#endif /* __SXD_EMAD_BUFFER_H__ */
